searchNodes=[{"doc":"Wasmex is a fast and secure WebAssembly and WASI runtime for Elixir. It enables lightweight WebAssembly containers to be run in your Elixir backend. It uses wasmer to execute WASM binaries through a NIF. We use Rust to implement the NIF to make it as safe as possible. This is the main module, providing most of the needed API to run WASM binaries. Each WASM module must be compiled from a .wasm file. A compiled module can be instantiated which usually happens in a GenServer . To start the GenServer, start_link/1 is used - it receives a variety of configuration options including function imports and optional WASI runtime options. { :ok , bytes } = File . read ( &quot;wasmex_test.wasm&quot; ) { :ok , module } = Wasmex.Module . compile ( bytes ) { :ok , instance } = Wasmex . start_link ( %{ module : module } ) { :ok , [ 42 ] } == Wasmex . call_function ( instance , &quot;sum&quot; , [ 50 , - 8 ] ) Memory of a WASM instance can be read/written using Wasmex.Memory : offset = 7 index = 4 value = 42 { :ok , memory } = Wasmex.Instance . memory ( instance , :uint8 , offset ) Wasmex.Memory . set ( memory , index , value ) IO . puts Wasmex.Memory . get ( memory , index ) # 42 See start_link/1 for starting a WASM instance and call_function/3 for details about calling WASM functions.","ref":"Wasmex.html","title":"Wasmex","type":"module"},{"doc":"Calls a function with the given name and params on the WebAssembly instance and returns its results. Strings as Parameters and Return Values Strings can not directly be used as parameters or return values when calling WebAssembly functions since WebAssembly only knows number data types. But since Strings are just &quot;a bunch of bytes&quot; we can write these bytes into memory and give our WebAssembly function a pointer to that memory location. Strings as Function Parameters Given we have the following Rust function that returns the first byte of a given string in our WebAssembly (note: this is copied from our test code, have a look there if you're interested): #[no_mangle] pub extern &quot;C&quot; fn string_first_byte(bytes: *const u8, length: usize) -&gt; u8 { let slice = unsafe { slice::from_raw_parts(bytes, length) }; match slice.first() { Some(&amp;i) =&gt; i, None =&gt; 0, } } Let's see how we can call this function from Elixir: { :ok , instance } = Wasmex . start_link ( %{ module : module } ) { :ok , memory } = Wasmex . memory ( instance , :uint8 , 0 ) index = 42 string = &quot;hello, world&quot; Wasmex.Memory . write_binary ( memory , index , string ) # 104 is the letter &quot;h&quot; in ASCII/UTF-8 encoding { :ok , [ 104 ] } == Wasmex . call_function ( instance , &quot;string_first_byte&quot; , [ index , String . length ( string ) ] ) Please not that Elixir and Rust assume Strings to be valid UTF-8. Take care when handling other encodings. Strings as Function Return Values Given we have the following Rust function in our WebAssembly (copied from our test code): #[no_mangle] pub extern &quot;C&quot; fn string() -&gt; *const u8 { b&quot;Hello, World!&quot;.as_ptr() } This function returns a pointer to its memory. This memory location contains the String &quot;Hello, World!&quot; (ending with a null-byte since in C-land all strings end with a null-byte to mark the end of the string). This is how we would receive this String in Elixir: { :ok , instance } = Wasmex . start_link ( %{ module : module } ) { :ok , memory } = Wasmex . memory ( instance , :uint8 , 0 ) { :ok , [ pointer ] } = Wasmex . call_function ( instance , &quot;string&quot; , [ ] ) returned_string = Wasmex.Memory . read_string ( memory , pointer , 13 ) # &quot;Hello, World!&quot;","ref":"Wasmex.html#call_function/3","title":"Wasmex.call_function/3","type":"function"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Wasmex.html#child_spec/1","title":"Wasmex.child_spec/1","type":"function"},{"doc":"Returns whether a function export with the given name exists in the WebAssembly instance.","ref":"Wasmex.html#function_exists/2","title":"Wasmex.function_exists/2","type":"function"},{"doc":"Params: module (Wasmex.Module): the compiled WASM module imports (map): a map defining imports. Structure is: %{ namespace_name : %{ import_name : { :fn , [ :i32 , :i32 ] , [ :i32 ] , function_reference } } } wasi (map): a map defining WASI support. Structure is: %{ args : [ &quot;string&quot; , &quot;arguments&quot; ] , env : %{ &quot;A_NAME_MAPS&quot; =&gt; &quot;to a value&quot; } , stdin : Pipe . create ( ) , stdout : Pipe . create ( ) , stderr : Pipe . create ( ) }","ref":"Wasmex.html#init/1","title":"Wasmex.init/1","type":"function"},{"doc":"Finds the exported memory of the given WASM instance and returns it as a Wasmex.Memory . The memory is a collection of bytes which can be viewed and interpreted as a sequence of different (data-) types : uint8 / int8 - (un-)signed 8-bit integer values uint16 / int16 - (un-)signed 16-bit integer values uint32 / int32 - (un-)signed 32-bit integer values We can think of it as a list of values of the above type (where each value may be larger than a byte). The offset value can be used to start reading the memory starting from the chosen position.","ref":"Wasmex.html#memory/3","title":"Wasmex.memory/3","type":"function"},{"doc":"Starts a GenServer which instantiates a WASM module from the given .wasm bytes. { :ok , bytes } = File . read ( &quot;wasmex_test.wasm&quot; ) { :ok , module } = Wasmex.Module . compile ( bytes ) { :ok , instance } = Wasmex . start_link ( %{ module : module } ) { :ok , [ 42 ] } == Wasmex . call_function ( instance , &quot;sum&quot; , [ 50 , - 8 ] ) Imports Imports are provided as a map of namespaces, each namespace being a nested map of imported functions: imports = %{ env : %{ sum3 : { :fn , [ :i32 , :i32 , :i32 ] , [ :i32 ] , fn ( _context , a , b , c ) -&gt; a + b + c end } , } } instance = Wasmex . start_link ( %{ module : module , imports : imports } ) { :ok , [ 6 ] } = Wasmex . call_function ( instance , &quot;use_the_imported_sum_fn&quot; , [ 1 , 2 , 3 ] ) In the example above, we import the &quot;env&quot; namespace. Each namespace is a map listing imports, e.g. the sum3 function, which is represented with a tuple of: the import type: :fn (a function), the functions parameter types: [:i32, :i32] , the functions return types: [:i32] , and the function to be executed: fn (_context, a, b, c) -&gt; a + b end The first param the function receives is always the call context (a Map containing e.g. the instances memory). All other params are regular parameters as specified by the parameter type list. Valid parameter/return types are: :i32 a 32 bit integer :i64 a 64 bit integer :f32 a 32 bit float :f64 a 64 bit float The return type must always be one value. WASI Optionally, modules can be run with WebAssembly System Interface (WASI) support. WASI functions are provided as native NIF functions by default. { :ok , instance } = Wasmex . start_link ( %{ module : module , wasi : true } ) It is possible to overwrite the default WASI functions using the imports map as described above. Oftentimes, WASI programs need additional input like environment variables, arguments, or file system access. These can be provided by giving a wasi map: wasi = %{ args : [ &quot;hello&quot; , &quot;from elixir&quot; ] , env : %{ &quot;A_NAME_MAPS&quot; =&gt; &quot;to a value&quot; , &quot;THE_TEST_WASI_FILE&quot; =&gt; &quot;prints all environment variables&quot; } , preopen : %{ &quot;wasi_logfiles&quot; : %{ flags : [ :write , :create ] , alias : &quot;log&quot; } } } { :ok , instance } = Wasmex . start_link ( %{ module : module , wasi : wasi } ) The preopen map takes directory paths as keys and settings map as values. Settings must specify the access map with one or more of :create , :read , :write . Optionally, the directory can be given another name in the WASI program using alias . It is also possible to capture stdout, stdin, or stderr of a WASI program using pipes: { :ok , stdin } = Wasmex.Pipe . create ( ) { :ok , stdout } = Wasmex.Pipe . create ( ) { :ok , stderr } = Wasmex.Pipe . create ( ) wasi = %{ stdin : stdin , stdout : stdout , stderr : stderr } { :ok , instance } = Wasmex . start_link ( %{ module : module , wasi : wasi } ) Wasmex.Pipe . write ( stdin , &quot;Hey! It compiles! Ship it!&quot; ) { :ok , _ } = Wasmex . call_function ( instance , :_start , [ ] ) Wasmex.Pipe . read ( stdout )","ref":"Wasmex.html#start_link/1","title":"Wasmex.start_link/1","type":"function"},{"doc":"Instantiates a WebAssembly module and allows calling exported functions on it. # Read a WASM file and compile it into a WASM module { :ok , bytes } = File . read ( &quot;wasmex_test.wasm&quot; ) { :ok , module } = Wasmex.Module . compile ( bytes ) # Instantiates the WASM module. { :ok , instance } = Wasmex . start_link ( %{ module : module } ) # Call a function on it. { :ok , [ result ] } = Wasmex . call_function ( instance , &quot;sum&quot; , [ 1 , 2 ] ) IO . puts result # 3 All exported functions are accessible via call_exported_function . Arguments of these functions are automatically casted to WebAssembly values. Note that WebAssembly only knows number datatypes (floats and integers of various sizes). You can pass arbitrary data to WebAssembly by writing data into an instances memory. The memory/3 function returns a Wasmex.Memory struct representing the memory of an instance, e.g.: { :ok , memory } = Wasmex.Instance . memory ( instance , :uint8 , 0 ) This module, especially call_exported_function/4 , is assumed to be called within a GenServer context. Usually, functions definedd here are called through the Wasmex module API to satisfy this assumption.","ref":"Wasmex.Instance.html","title":"Wasmex.Instance","type":"module"},{"doc":"Calls a function with the given name and params on the WebAssembly instance . This function assumes to be called within a GenServer context, it expects a from argument as given by handle_call etc. The WebAssembly function will be invoked asynchronously in a new OS thread. The calling process will receive a {:returned_function_call, result, from} message once the execution finished. The result either is an {:error, reason} or the :ok atom. A BadArg exception may be thrown when given unexpected input data.","ref":"Wasmex.Instance.html#call_exported_function/4","title":"Wasmex.Instance.call_exported_function/4","type":"function"},{"doc":"","ref":"Wasmex.Instance.html#from_bytes/2","title":"Wasmex.Instance.from_bytes/2","type":"function"},{"doc":"","ref":"Wasmex.Instance.html#function_export_exists/2","title":"Wasmex.Instance.function_export_exists/2","type":"function"},{"doc":"","ref":"Wasmex.Instance.html#memory/3","title":"Wasmex.Instance.memory/3","type":"function"},{"doc":"","ref":"Wasmex.Instance.html#new/2","title":"Wasmex.Instance.new/2","type":"function"},{"doc":"","ref":"Wasmex.Instance.html#new_wasi/3","title":"Wasmex.Instance.new_wasi/3","type":"function"},{"doc":"","ref":"Wasmex.Instance.html#wasi_from_bytes/3","title":"Wasmex.Instance.wasi_from_bytes/3","type":"function"},{"doc":"","ref":"Wasmex.Instance.html#t:t/0","title":"Wasmex.Instance.t/0","type":"type"},{"doc":"A WebAssembly instance has its own memory, represented by the Wasmex.Memory struct. It is accessible by the Wasmex.Instance.memory/3 getter. The grow/2 method allows to grow the memory by a number of pages (of 65kb each). Wasmex.Memory . grow ( memory , 1 ) The current size of the memory can be obtained with the length/1 method: Wasmex.Memory . length ( memory ) # in bytes, always a multiple of the the page size (65kb) When creating the memory struct, the offset param can be provided, to subset the memory array at a particular offset. offset = 7 index = 4 value = 42 { :ok , memory } = Wasmex.Instance . memory ( instance , :uint8 , offset ) Wasmex.Memory . set ( memory , index , value ) IO . puts Wasmex.Memory . get ( memory , index ) # 42 Memory Buffer viewed in different Datatypes The Wasmex.Memory struct views the WebAssembly memory of an instance as an array of values of different types. Possible types are: uint8 , int8 , uint16 , int16 , uint32 , and int32 . The underlying data is not changed when viewed in different types - it is just its representation that changes. View memory buffer as a sequence of… Bytes per element int8 1 uint8 1 int16 2 uint16 2 int32 4 uint32 4 This can be resolved at runtime: { :ok , memory } = Wasmex . memory ( instance , :uint16 , 0 ) Wasmex.Memory . bytes_per_element ( memory ) # 2 Since the same memory seen in different data types uses the same buffer internally. Let's have some fun: int8 = Wasmex . memory ( instance , :int8 , 0 ) int16 = Wasmex . memory ( instance , :int16 , 0 ) int32 = Wasmex . memory ( instance , :int32 , 0 ) b ₁ ┌ ┬ ┬ ┬ ┬ ┬ ┬ ┐ Memory . set ( int8 , 0 , 0b00000001 ) b ₂ ┌ ┬ ┬ ┬ ┬ ┬ ┬ ┐ Memory . set ( int8 , 1 , 0b00000100 ) b ₃ ┌ ┬ ┬ ┬ ┬ ┬ ┬ ┐ Memory . set ( int8 , 2 , 0b00010000 ) b ₄ ┌ ┬ ┬ ┬ ┬ ┬ ┬ ┐ Memory . set ( int8 , 3 , 0b01000000 ) # Viewed in `int16`, 2 bytes are read per value b ₂ b ₁ ┌ ┬ ┬ ┬ ┬ ┬ ┬ ┐ ┌ ┬ ┬ ┬ ┬ ┬ ┬ ┐ assert 0b00000100_00000001 == Memory . get ( int16 , 0 ) b ₄ b ₃ ┌ ┬ ┬ ┬ ┬ ┬ ┬ ┐ ┌ ┬ ┬ ┬ ┬ ┬ ┬ ┐ assert 0b01000000_00010000 == Memory . get ( int16 , 1 ) # Viewed in `int32`, 4 bytes are read per value b ₄ b ₃ b ₂ b ₁ ┌ ┬ ┬ ┬ ┬ ┬ ┬ ┐ ┌ ┬ ┬ ┬ ┬ ┬ ┬ ┐ ┌ ┬ ┬ ┬ ┬ ┬ ┬ ┐ ┌ ┬ ┬ ┬ ┬ ┬ ┬ ┐ assert 0b01000000_00010000_00000100_00000001 == Memory . get ( int32 , 0 )","ref":"Wasmex.Memory.html","title":"Wasmex.Memory","type":"module"},{"doc":"Returns the number of bytes used to represent a unit in memory. For the limited number of unit sizes the byte values are the following: size | Bytes per element | |----------|---| | int8 | 1 | | uint8 | 1 | | int16 | 2 | | uint16 | 2 | | int32 | 4 | | uint32 | 4 | { :ok , memory } = Wasmex.Instance . memory ( instance , :uint16 , 0 ) Wasmex.Memory . bytes_per_element ( memory ) # 2 Alternatively, the size atom can be given directly: Wasmex.Memory . bytes_per_element ( :uint32 ) # 4","ref":"Wasmex.Memory.html#bytes_per_element/1","title":"Wasmex.Memory.bytes_per_element/1","type":"function"},{"doc":"","ref":"Wasmex.Memory.html#from_instance/1","title":"Wasmex.Memory.from_instance/1","type":"function"},{"doc":"","ref":"Wasmex.Memory.html#from_instance/3","title":"Wasmex.Memory.from_instance/3","type":"function"},{"doc":"","ref":"Wasmex.Memory.html#get/2","title":"Wasmex.Memory.get/2","type":"function"},{"doc":"","ref":"Wasmex.Memory.html#get/4","title":"Wasmex.Memory.get/4","type":"function"},{"doc":"Grows the amount of available memory by the given number of pages and returns the number of previously available pages. Note that the maximum number of pages is 65_536","ref":"Wasmex.Memory.html#grow/2","title":"Wasmex.Memory.grow/2","type":"function"},{"doc":"Returns the number of elements that fit into memory for the given unit size and offset. Note that the WebAssembly memory consists of pages of 65kb each. Different unit size s needs a different number of bytes per element and the offset may reduce the number of available elements. { :ok , memory } = Wasmex.Memory . from_instance ( instance , :uint8 , 0 ) Wasmex.Memory . length ( memory ) # 1114112 (17 * 65_536)","ref":"Wasmex.Memory.html#length/1","title":"Wasmex.Memory.length/1","type":"function"},{"doc":"Same as length/1 except the unit size and offset given at memory creation are overwritten by the given values. { :ok , memory } = Wasmex.Instance . memory ( instance ) Wasmex.Memory . length ( memory , :uint8 , 0 ) # 1114112 (17 * 65_536)","ref":"Wasmex.Memory.html#length/3","title":"Wasmex.Memory.length/3","type":"function"},{"doc":"","ref":"Wasmex.Memory.html#read_binary/3","title":"Wasmex.Memory.read_binary/3","type":"function"},{"doc":"","ref":"Wasmex.Memory.html#read_binary/5","title":"Wasmex.Memory.read_binary/5","type":"function"},{"doc":"","ref":"Wasmex.Memory.html#read_string/3","title":"Wasmex.Memory.read_string/3","type":"function"},{"doc":"","ref":"Wasmex.Memory.html#read_string/5","title":"Wasmex.Memory.read_string/5","type":"function"},{"doc":"","ref":"Wasmex.Memory.html#set/3","title":"Wasmex.Memory.set/3","type":"function"},{"doc":"","ref":"Wasmex.Memory.html#set/5","title":"Wasmex.Memory.set/5","type":"function"},{"doc":"","ref":"Wasmex.Memory.html#wrap_resource/3","title":"Wasmex.Memory.wrap_resource/3","type":"function"},{"doc":"","ref":"Wasmex.Memory.html#write_binary/3","title":"Wasmex.Memory.write_binary/3","type":"function"},{"doc":"","ref":"Wasmex.Memory.html#write_binary/5","title":"Wasmex.Memory.write_binary/5","type":"function"},{"doc":"","ref":"Wasmex.Memory.html#t:t/0","title":"Wasmex.Memory.t/0","type":"type"},{"doc":"A compiled WebAssembly module. A WebAssembly Module contains stateless WebAssembly code that has already been compiled and can be instantiated multiple times. # Read a WASM file and compile it into a WASM module { :ok , bytes } = File . read ( &quot;wasmex_test.wasm&quot; ) { :ok , module } = Wasmex.Module . compile ( bytes ) # use the compiled module to start as many running instances as you want { :ok , instance } = Wasmex . start_link ( %{ module : module } )","ref":"Wasmex.Module.html","title":"Wasmex.Module","type":"module"},{"doc":"Compiles a WASM module from it's WASM (usually a .wasm file) or WAT (usually a .wat file) representation. Compiled modules can be instantiated using Wasmex.start_link/1 . Since module compilation takes time and resources but instantiation is comparatively cheap, it may be a good idea to compile a module once and instantiate it often if you want to run a WASM binary multiple times.","ref":"Wasmex.Module.html#compile/1","title":"Wasmex.Module.compile/1","type":"function"},{"doc":"Lists all exports of a WebAssembly module. Returns a map which has the exports name (string) as key and export info-tuples as values. Info tuples always start with an atom indicating the exports type: :fn (function) :global :table :memory Further parts of the info tuple vary depending on the type.","ref":"Wasmex.Module.html#exports/1","title":"Wasmex.Module.exports/1","type":"function"},{"doc":"Lists all imports of a WebAssembly module grouped by their module namespace. Returns a map of namespaces, each being a map which has the imports name (string) as key and import info-tuples as values. Info tuples always start with an atom indicating the imports type: :fn (function) :global :table :memory Further parts of the info tuple vary depending on the type.","ref":"Wasmex.Module.html#imports/1","title":"Wasmex.Module.imports/1","type":"function"},{"doc":"Returns the name of the current module if a name is given. This name is normally set in the WebAssembly bytecode by some compilers, but can be also overwritten using set_name/2 .","ref":"Wasmex.Module.html#name/1","title":"Wasmex.Module.name/1","type":"function"},{"doc":"Serializes a compiled WASM module into a binary. The generated binary can be deserialized back into a module using unsafe_deserialize/1 . It is unsafe do alter the binary in any way. See unsafe_deserialize/1 for safety considerations.","ref":"Wasmex.Module.html#serialize/1","title":"Wasmex.Module.serialize/1","type":"function"},{"doc":"Sets the name of the current module. This is normally useful for stacktraces and debugging. It will return :ok if the module name was changed successfully, and return an {:error, reason} tuple otherwise (in case the module is already instantiated).","ref":"Wasmex.Module.html#set_name/2","title":"Wasmex.Module.set_name/2","type":"function"},{"doc":"Deserializes a module from its binary representation. This function is inherently unsafe as the provided binary: Is going to be deserialized directly into Rust objects. Contains the WASM function assembly bodies and, if intercepted, a malicious actor could inject code into executable memory. And as such, the deserialize method is unsafe. Only pass binaries directly coming from serialize/1 , never any user input. Best case is it crashing the NIF, worst case is malicious input doing... malicious things. The deserialization must be done on the same CPU architecture as the serialization (e.g. don't serialize a x86_64-compiled module and deserialize it on ARM64).","ref":"Wasmex.Module.html#unsafe_deserialize/1","title":"Wasmex.Module.unsafe_deserialize/1","type":"function"},{"doc":"","ref":"Wasmex.Module.html#t:t/0","title":"Wasmex.Module.t/0","type":"type"},{"doc":"A Pipe is a memory buffer that can be used in exchange for a WASM file. It can be used, for example, to capture stdout/stdin/stderr of a WASI program.","ref":"Wasmex.Pipe.html","title":"Wasmex.Pipe","type":"module"},{"doc":"Creates and returns a new Pipe.","ref":"Wasmex.Pipe.html#create/0","title":"Wasmex.Pipe.create/0","type":"function"},{"doc":"Reads all available bytes from the Pipe and returns them as a binary.","ref":"Wasmex.Pipe.html#read/1","title":"Wasmex.Pipe.read/1","type":"function"},{"doc":"Attempts to resize the pipe to the given number of bytes.","ref":"Wasmex.Pipe.html#set_len/2","title":"Wasmex.Pipe.set_len/2","type":"function"},{"doc":"Returns the current size in bytes of the Pipe.","ref":"Wasmex.Pipe.html#size/1","title":"Wasmex.Pipe.size/1","type":"function"},{"doc":"","ref":"Wasmex.Pipe.html#wrap_resource/1","title":"Wasmex.Pipe.wrap_resource/1","type":"function"},{"doc":"Writes the given binary into the pipe.","ref":"Wasmex.Pipe.html#write/2","title":"Wasmex.Pipe.write/2","type":"function"},{"doc":"","ref":"Wasmex.Pipe.html#t:t/0","title":"Wasmex.Pipe.t/0","type":"type"}]